<?php
/*************************
  Coppermine Photo Gallery
  ************************
  Copyright (c) 2003-2007 Coppermine Dev Team
  v1.1 originally written by Gregory DEMAR

  This program is free software; you can redistribute it and/or modify
  it under the terms of the GNU General Public License as published by
  the Free Software Foundation; either version 2 of the License, or
  (at your option) any later version.
  ********************************************
  Coppermine version: 1.4.11
  $Source$
  $Revision: 3406 $
  $Author: gaugau $
  $Date: 2006-12-27 10:12:12 +0100 (Wed, 27 Dec 2006) $
**********************************************/

/*

Code mod to conf/_advanced.php

//$cookie_path = preg_replace( '#https?://[^/]+#', '', $baseurl );
$cookie_path = '/'; // Let Coppermine see the cookie.

Change $instance_name below if you changed your instance name away from default (b2evo)

*/

if (!defined('IN_COPPERMINE')) die('Not in Coppermine...');

// Switch that allows overriding the bridge manager with hard-coded values
define('USE_BRIDGEMGR', 1);

require_once 'bridge/udb_base.inc.php';

class cpg_udb extends core_udb {

	function cpg_udb()
	{
		global $BRIDGE, $CONFIG;
		
		define('EVO_CONFIG_LOADED', 1);
		
		require_once($BRIDGE['relative_path_to_config_file'] . 'conf/_basic_config.php'); // for DB info

		$this->boardurl = $baseurl;
		$this->use_post_based_groups = $BRIDGE['use_post_based_groups'];
		
		$instance_name = 'b2evo'; // change if required
		
		$this->multigroups = 0;
		$this->group_overrride = 1;

		// Database connection settings
		$this->db = array(
			'name' => $db_config['name'],
			'host' => $db_config['host'],
			'user' => $db_config['user'],
			'password' => $db_config['password'],
			'prefix' => $tableprefix,
		);
		
		// Board table names
		$this->table = array(
			'users' => 'users',
			'groups' => 'groups',
			'sessions' => 'sessions',
		);

		// Derived full table names
		$this->usertable = '`' . $this->db['name'] . '`.' . $this->db['prefix'] . $this->table['users'];
		$this->groupstable =  '`' . $this->db['name'] . '`.' . $this->db['prefix'] . $this->table['groups'];
		$this->sessionstable =  '`' . $this->db['name'] . '`.' . $this->db['prefix'] . $this->table['sessions'];
		
		// Table field names
		$this->field = array(
			'username' => 'user_nickname', // name of 'username' field in users table
			'user_id' => 'user_ID', // name of 'id' field in users table
			'password' => 'user_pass', // name of 'password' field in users table
			'email' => 'user_email', // name of 'email' field in users table
			'regdate' => 'UNIX_TIMESTAMP(dateYMDhour)', // name of 'registered' field in users table
			'location' => "''", // name of 'location' field in users table
			'website' => 'user_url', // name of 'website' field in users table
			'lastvisit' => "''", // name of 'location' field in users table
			'usertbl_group_id' => 'user_grp_ID', // name of 'group id' field in users table
			'grouptbl_group_id' => 'grp_ID', // name of 'group id' field in groups table
			'grouptbl_group_name' => 'grp_name' // name of 'group name' field in groups table
		);
		
		// Pages to redirect to
		$this->page = array(
			'register' => 'htsrv/register.php?redirect_to='.urlencode($CONFIG['site_url']),
			'editusers' => 'admin.php?ctrl=users',
			'edituserprofile' => 'index.php?blog=1&disp=profile&redirect_to=' . urlencode($CONFIG['site_url']) . '&uid=',
		);
		
		// Group ids
		$this->admingroups = array(1);
		$this->guestgroup = 99;
		
		// Cookie settings - used in following functions only
		$this->cookie_name = 'cookie'.$instance_name.'session';
		
		// Connect to db
		$this->connect();
	}

	// definition of how to extract id, name, group from a session cookie
	function session_extraction()
	{
		if (!isset($_COOKIE[$this->cookie_name])) return false;
		
		if (!preg_match( '~^(\d+)_(\w+)$~', $_COOKIE[$this->cookie_name], $match)) return false;
		
		$session_id_by_cookie = $match[1];
		$session_key_by_cookie = $match[2];
		
		$sql = "SELECT {$this->field['user_id']} AS user_id, {$this->field['password']}
			FROM {$this->sessionstable}
			INNER JOIN {$this->usertable}
			ON sess_user_ID = {$this->field['user_id']}
			AND sess_key = '$session_key_by_cookie'
			AND sess_ID = $session_id_by_cookie";
			// AND user_validated = 1
			
		$result = cpg_db_query($sql, $this->link_id);
		
		return mysql_fetch_row($result);
	}
	
	// Login
	function login_page()
	{
		global $CONFIG;
		
		$this->redirect('htsrv/login.php?redirect_to='.urlencode($CONFIG['site_url']));
	}

	// Logout
	function logout_page()
	{
		global $CONFIG;

		$this->redirect('htsrv/login.php?action=logout&redirect_to='.urlencode($CONFIG['site_url']));
	}
	
	function view_users() {
		$this->redirect('admin.php?ctrl=users');
	}
	
	function view_profile($uid) {
	}
	
	function udb_hash_db($password)
	{
		return $password; // unused
	}
	
	// needed to add in an anonymous group
	function collect_groups()
	{
		$sql ="SELECT * FROM {$this->groupstable}";
	
		$result = cpg_db_query($sql, $this->link_id);
		
		$udb_groups = array(99 => 'Guests');
			
		while ($row = mysql_fetch_assoc($result))
		{
			$udb_groups[$row[$this->field['grouptbl_group_id']]+100] = utf_ucfirst(utf_strtolower($row[$this->field['grouptbl_group_name']]));
		}

		return $udb_groups;
	}
}

// and go !
$cpg_udb = new cpg_udb;
?>
